# Advanced & Troubleshooting

- [Advanced Guides](https://docs.obol.org/next/advanced-and-troubleshooting/advanced.md)
- [Swapping Clients](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/client-swap.md): Swap EL, CL, VC and MEV clients in the stack.
- [Migrate an Existing Validator](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/quickstart-split.md): Migrate an existing validator by splitting its private key into shares
- [Create a DV Using the SDK](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/create-a-dv-using-the-sdk.md)
- [Pre-Create a DV with an OVM](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/ovm-predeploy.md): Assign pre-created validators to customers on demand
- [Enable MEV](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/enable-mev.md)
- [Change Fee Recipient](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/change-fee-recipient.md): Change the fee recipient address for validators in a distributed validator cluster.
- [Combine DV Private Key Shares](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/quickstart-combine.md): Combine distributed validator private key shares to recover the validator private key.
- [Beacon node authentication](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/beacon-node-authentication.md): Send authenticated requests to a beacon node protected by HTTP Basic, or header-based access control.
- [Alter Withdrawal Addresses](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/alter-withdrawal-addresses.md): Prepare an alternative deposit for an unused validator
- [Partial Deposits](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/partial-deposit.md): Submit and fetch (partial) deposits.
- [Custom Graffiti](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/custom-graffiti.md): Add custom graffiti to your block proposals
- [Enable TLS Protocol](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/enable-tls-protocol.md): Enable the TLS protocol to secure HTTPS requests made by the Validator Client to Charon.
- [Fallback Beacon Nodes](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/fallback-beacon-nodes.md): Add fallback beacon nodes to use when primary beacon node fails
- [Set a Nickname](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/nicknames.md): Add a nickname to your Charon node
- [Self-Host a Relay](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/self-relay.md): Self-host a relay
- [Advanced Docker Configs](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/adv-docker-configs.md): Use advanced docker-compose features to have more flexibility and power to change the default configuration.
- [Assign OVM Roles](https://docs.obol.org/next/advanced-and-troubleshooting/advanced/assign-ovm-roles.md): Learn how to assign permissions within the Obol Vault Manager (OVM) smart contract using the efficient bitwise role system.
- [Troubleshooting](https://docs.obol.org/next/advanced-and-troubleshooting/troubleshooting.md)
- [Errors & Resolutions](https://docs.obol.org/next/advanced-and-troubleshooting/troubleshooting/errors.md): Errors & Resolutions
- [Handling DKG Failure](https://docs.obol.org/next/advanced-and-troubleshooting/troubleshooting/dkg_failure.md): Handling DKG failure
- [Client Configuration](https://docs.obol.org/next/advanced-and-troubleshooting/troubleshooting/client_configurations.md): A reference for extra configuration of Ethereum Clients when running in DVs.
- [Test Commands](https://docs.obol.org/next/advanced-and-troubleshooting/troubleshooting/test_command.md): Troubleshoot issues spotted by the test command
- [Security](https://docs.obol.org/next/advanced-and-troubleshooting/security.md)
- [Overview](https://docs.obol.org/next/advanced-and-troubleshooting/security/overview.md): Security Overview
- [Centralization Risks and Mitigation](https://docs.obol.org/next/advanced-and-troubleshooting/security/risks.md): Outlining potential centralization risks and their mitigations
- [Obol Bug Bounty Program](https://docs.obol.org/next/advanced-and-troubleshooting/security/bug-bounty.md): Bug Bounty Policy
- [Smart Contract Audit](https://docs.obol.org/next/advanced-and-troubleshooting/security/smart-contract-audit.md)
- [Software Development at Obol](https://docs.obol.org/next/advanced-and-troubleshooting/security/ev-assessment.md): Software Development Security Assessment
- [Charon Threat Model](https://docs.obol.org/next/advanced-and-troubleshooting/security/threat_model.md): Threat model for a Distributed Validator
- [Contacts](https://docs.obol.org/next/advanced-and-troubleshooting/security/contact.md): Security details for the Obol Network


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.obol.org/next/advanced-and-troubleshooting.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
